(defun so:dialog (/ id co_delat vysledek)

  (setq id (load_dialog "d:/vyber.dcl"))	;;; pedn jmna dialogovho boxu
    ;;; CESTU K UMSTN DIALOGU SE MUS AKTUALIZOVAT PODLE AKTUALNHO UMSTN

  (setq co_delat 2)
  (while (>= co_delat 2)			;;; opakuj pokud nenastane zmena
    (if	(not (new_dialog "vyber" id))		;;; nen-li jmno dialogu vyber tak skoni
      (exit)
    )
    (start_list "popup")	;;; vytvoen poloek popup listu
      (add_list "N helnk")	;;; pidn poloky "N helnk"
      (add_list "Krunice")	;;; pidn poloky "Krunice"
    (end_list)

    ;;; nastaven hodnot dialogovch prvk
    (set_tile "polomerke"    (cdr (assoc "polomerke"    gl_pam_hodnoty)))
    (set_tile "polomerks"    (cdr (assoc "polomerks"    gl_pam_hodnoty)))
    (set_tile "pocetke"      (cdr (assoc "pocetke"      gl_pam_hodnoty)))
    (set_tile "pocetks"      (cdr (assoc "pocetks"      gl_pam_hodnoty)))
    (set_tile "vzdalenostke" (cdr (assoc "vzdalenostke" gl_pam_hodnoty)))
    (set_tile "vzdalenostks" (cdr (assoc "vzdalenostks" gl_pam_hodnoty)))
    (set_tile "polomerne"    (cdr (assoc "polomerne"    gl_pam_hodnoty)))
    (set_tile "polomerns"    (cdr (assoc "polomerns"    gl_pam_hodnoty)))
    (set_tile "pocetne"      (cdr (assoc "pocetne"      gl_pam_hodnoty)))
    (set_tile "pocetns"      (cdr (assoc "pocetns"      gl_pam_hodnoty)))
    (set_tile "vzdalenostne" (cdr (assoc "vzdalenostne" gl_pam_hodnoty)))
    (set_tile "vzdalenostns" (cdr (assoc "vzdalenostns" gl_pam_hodnoty)))
    (set_tile "pocvrcholune" (cdr (assoc "pocvrcholune" gl_pam_hodnoty)))
    (set_tile "pocvrcholuns" (cdr (assoc "pocvrcholuns" gl_pam_hodnoty)))
    (set_tile "stredkex"     (cdr (assoc "stredkex"     gl_pam_hodnoty)))
    (set_tile "stredkey"     (cdr (assoc "stredkey"     gl_pam_hodnoty)))
    (set_tile "stredkez"     (cdr (assoc "stredkez"     gl_pam_hodnoty)))
    (set_tile "strednex"     (cdr (assoc "strednex"     gl_pam_hodnoty)))
    (set_tile "stredney"     (cdr (assoc "stredney"     gl_pam_hodnoty)))
    (set_tile "strednez"     (cdr (assoc "strednez"     gl_pam_hodnoty)))

    (action_tile "kruznice" "(so:naskruh)")
		;;; je-li vybrn radio_button "kruznice" zavolej funkci (so:naskruh)
    (action_tile "nuhelnik" "(so:nasnuhe)")
		;;; je-li vybrn radio_button "nuhelnik" zavolej funkci (so:nasnuhe)
    (action_tile "popup"
      "(progn
         (if (= $value \"0\")(so:nasnuhe))			
         (if (= $value \"1\") (so:naskruh))
	)"
    )
		;;; je-li vybrna poloka popup_listu "N helnk" zavolej funkci (so:nasnuhe)
		;;; je-li vybrna poloka popup_listu "Krunice" zavolej funkci (so:naskruh)
    (action_tile "polomerks" "(so:vazba_prvku $value $reason \"polomerke\"  \"polomerks\")")
    (action_tile "pocetks"   "(so:vazba_prvku $value $reason \"pocetke\"    \"pocetks\")")
    (action_tile "vzdalenostks"	"(so:vazba_prvku $value $reason \"vzdalenostke\" \"vzdalenostks\")")
    (action_tile "polomerns" "(so:vazba_prvku $value $reason \"polomerne\"  \"polomerns\")")
    (action_tile "pocetns"   "(so:vazba_prvku $value $reason \"pocetne\"    \"pocetns\")")
    (action_tile "vzdalenostns"	"(so:vazba_prvku $value $reason \"vzdalenostne\" \"vzdalenostns\")")
    (action_tile "pocvrcholuns"	"(so:vazba_prvku $value $reason \"pocvrcholune\" \"pocvrcholuns\")")
		;;; je-li zmnn nkter posuvnk "slider.." zavolej funkci so:vazba_prvk
    (action_tile "stredkex"
       "(setq gl_pam_hodnoty
        (subst
          (cons \"stredkex\" $value)
          (assoc \"stredkex\" gl_pam_hodnoty)
          gl_pam_hodnoty
        ))"
    )
    (action_tile "stredkey"
       "(setq gl_pam_hodnoty
        (subst
          (cons \"stredkey\" $value)
          (assoc \"stredkey\" gl_pam_hodnoty)
          gl_pam_hodnoty
        ))"
    )
    (action_tile "stredkez"
       "(setq gl_pam_hodnoty
        (subst
          (cons \"stredkez\" $value)
          (assoc \"stredkez\" gl_pam_hodnoty)
          gl_pam_hodnoty
        ))"
    )
		;;; je-li zmnn nkter editbox stedu krunice nastav odpovdajc hodnoty
    (action_tile "polomerke" "(so:vazba_prvku $value $reason \"polomerke\" \"polomerks\")")
    (action_tile "pocetke"
      		 "(so:vazba_prvku (zaokr_string $value) $reason \"pocetke\" \"pocetks\")"
    )
    (action_tile "vzdalenostke"	"(so:vazba_prvku $value $reason \"vzdalenostke\" \"vzdalenostks\")")
		;;; je-li zmnn nkter editbox zavolej funkci so:vazba_prvku
    (action_tile "strednex"
       "(setq gl_pam_hodnoty
        (subst
          (cons \"strednex\" $value)
          (assoc \"strednex\" gl_pam_hodnoty)
          gl_pam_hodnoty
        ))"
    )
    (action_tile "stredney"
       "(setq gl_pam_hodnoty
        (subst
          (cons \"stredney\" $value)
          (assoc \"stredney\" gl_pam_hodnoty)
          gl_pam_hodnoty
        ))"
    )
    (action_tile "strednez"
       "(setq gl_pam_hodnoty
        (subst
          (cons \"strednez\" $value)
          (assoc \"strednez\" gl_pam_hodnoty)
          gl_pam_hodnoty
        ))"
    )
		;;; je-li zmnn nkter editbox stedu n-helnku nastav odpovdajc hodnoty
    (action_tile "polomerne" "(so:vazba_prvku $value $reason \"pocvrcholune\" \"polomerns\")")
    (action_tile "pocetne"
      		 "(so:vazba_prvku (zaokr_string $value) $reason \"pocetne\" \"pocetns\")")
    (action_tile "vzdalenostne"	"(so:vazba_prvku $value $reason \"vzdalenostne\" \"vzdalenostns\")")
    (action_tile "pocvrcholune"
		 "(so:vazba_prvku (zaokr_string $value) $reason \"pocvrcholune\" \"pocvrcholuns\")")
		;;; je-li zmnn nkter editbox zavolej funkci so:vazba_prvku
    		;;; pozor hodnota $value je u nkterch prvk zaokrouhlena
    (action_tile "kruz_stred_but" "(done_dialog 4)")
		;;; je-li zmknuto tlatko "kruz_stred_but" zavolej
    		;;; funkci done_dialog s hodnotou 4
    (action_tile "nuhel_stred_but" "(done_dialog 4)")
		;;; je-li zmknuto tlatko "nuhel_stred_but" zavolej
    		;;; funkci done_dialog s hodnotou 4
    (action_tile "accept" "(done_dialog 1)")
		;;; je-li zmknuto tlatko "accept"
    		;;; zavolej funkci done_dialog s hodnotou 1
    (action_tile "cancel" "(done_dialog 0)")
		;;; je-li zmknuto tlatko "cancel"
    		;;; zavolej funkci done_dialog s hodnotou 0
    (if (= (cdr (assoc "co_kreslit" gl_pam_hodnoty)) "Kruznice")
			;;; je-li nastaveno kresleni kruznice
      (so:naskruh)	;;; zavolej fukci (so:naskruh)
    )
    (if (= (cdr (assoc "co_kreslit" gl_pam_hodnoty)) "N-uhelnik")
			;;; nen-li nastaveno kresleni n-helnku
      (so:nasnuhe)	;;; zavolej funkci (so:nasnuhe)
    )
    (setq co_delat (start_dialog))
		;;; nastav promnnou na hodnotu zskanou od funkce start_dialog
		;;; (hodnota s kterou kon funkce done_dialog)
    (cond	;;; uren dal innosti
      ((= co_delat 0) (setq vysledek nil))	;;; uivatel stornoval dialog = konec funce
      ((= co_delat 1) (setq vysledek T))	;;; uivatel potvrdil dialog,
      						;;; zavolej funkci (vykresli)
      ((= co_delat 4) (so:nastav_stred (getpoint "\nVbr bodu:")))
				;;; uivatel zmkl tlatko pro zadn souadnic stedu
	    			;; zavolej funkci nastav_sted
    )
  )
  (unload_dialog id)		;;; odstran dialog id z pamti
    vysledek			;;; vrcen vsledku funkce (jestli probhla OK)
)


(defun so:naskruh ()
;;; nastaven hodnot (pepna) a viditelnosti prvk pro   nabdku krunice
  (setq gl_pam_hodnoty 
    (subst
      (cons "co_kreslit" "Kruznice")
      (assoc "co_kreslit" gl_pam_hodnoty)
      gl_pam_hodnoty
    )
  )			;;; nastaven aktulnho objeku v asoc. seznamu na hodnotu "Kruznice"

  (set_tile "kruznice" "1")	;;; nastaven radio_buttunu "kruznice" jako zvraznn
  (set_tile "nuhelnik" "0")	;;; nastaven radio_buttunu "n uhelnik" jako nezvraznn
  (set_tile "popup"    "1")	;;; nastaven popup_listu na hodnotu "Krunice"

;;; deaktivovn prvk   pslunch k n-helnku:
  (mode_tile "strednex"     1)	;;; deaktivovn edit_boxu "strednex"
  (mode_tile "stredney"     1)	;;; deaktivovn edit_boxu "stredney"
  (mode_tile "strednez"     1)	;;; deaktivovn edit_boxu "strednez"
  (mode_tile "polomerne"    1)	;;; deaktivovn edit_boxu "polomerne"
  (mode_tile "pocetne"      1)	;;; deaktivovn edit_boxu "pocetne"
  (mode_tile "vzdalenostne" 1)	;;; deaktivovn edit_boxu "vzdalenostne" 
  (mode_tile "pocvrcholune" 1)	;;; deaktivovn edit_boxu "pocvrcholune"
  (mode_tile "polomerns"    1)	;;; deaktivovn slideru "polomerns"
  (mode_tile "pocetns"      1)	;;; deaktivovn slideru "pocetns" 
  (mode_tile "vzdalenostns" 1)	;;; deaktivovn slideru "vzdalenostns" 
  (mode_tile "pocvrcholuns" 1)	;;; deaktivovn slideru "pocvrcholuns"
  (mode_tile "nuhel_stred_but" 1)	;;; deaktivovn tlatka "nuhel_stred_but" 
;;; aktivovn   prvk pslunch ke krunici:
  (mode_tile "polomerks"    0)	;;; aktivovn slideru "polomerks"
  (mode_tile "pocetks"     0)	;;; aktivovn slideru "pocetks"
  (mode_tile "vzdalenostks" 0)	;;; aktivovn slideru "vzdalenostks" 
  (mode_tile "stredkex"    0)	;;; aktivovn edit_boxu "stredkex"
  (mode_tile "stredkey"    0)	;;; aktivovn edit_boxu "stredkey" 
  (mode_tile "stredkez"     0)	;;; aktivovn edit_boxu "stredkez"
  (mode_tile "polomerke"    0)	;;; aktivovn edit_boxuu "polomerke"
  (mode_tile "pocetke"      0)	;;; aktivovn edit_boxu "pocetke" 
  (mode_tile "vzdalenostke" 0)	;;; aktivovn edit_boxu "vzdalenostke"
  (mode_tile "kruz_stred_but" 0)	;;; aktivovn tlatka "kruz_stred_but"
)
  


(defun so:nasnuhe ()
;;; nastaven hodnot (pepna) a viditelnosti prvk pro   nabdku n-helnk
  (setq gl_pam_hodnoty 
    (subst
      (cons "co_kreslit" "N-uhelnik")
      (assoc "co_kreslit" gl_pam_hodnoty)
      gl_pam_hodnoty
    )
  )		;;; nastaven aktulnho objeku v asoc. seznamu na hodnotu "Kruznice"
  
  (set_tile "kruznice" "0")	;;; nastaven radio_buttunu "kruznice" jako nezvraznn
  (set_tile "nuhelnik" "1")	;;; nastaven radio_buttunu "n uhelnik" jako zvraznn
  (set_tile "popup"    "0")	;;; nastaven popup_listu na hodnotu "N - helnk"

;;; deaktivovn prvk   pslunch ke krunici:
  (mode_tile "polomerks"    1)	;;; deaktivovn slideru "polomerks"
  (mode_tile "pocetks"      1)	;;; deaktivovn slideru "pocetks"
  (mode_tile "vzdalenostks" 1)	;;; deaktivovn slideru "vzdalenostks" 
  (mode_tile "stredkex"     1)	;;; deaktivovn edit_boxu "stredkex"
  (mode_tile "stredkey"     1)	;;; deaktivovn edit_boxu "stredkey" 
  (mode_tile "stredkez"     1)	;;; deaktivovn edit_boxu "stredkez"
  (mode_tile "polomerke"    1)	;;; deaktivovn edit_boxuu "polomerke"
  (mode_tile "pocetke"      1)	;;; deaktivovn edit_boxu "pocetke" 
  (mode_tile "vzdalenostke" 1)	;;; deaktivovn edit_boxu "vzdalenostke"
  (mode_tile "kruz_stred_but" 1)	;;; deaktivovn tlatka "kruz_stred_but"
;;; aktivovn prvk pslunch   k n-helnku:
  (mode_tile "strednex"     0)	;;; aktivovn edit_boxu "strednex"
  (mode_tile "stredney"     0)	;;; aktivovn edit_boxu "stredney"
  (mode_tile "strednez"     0)	;;; aktivovn edit_boxu "strednez"
  (mode_tile "polomerne"    0)	;;; aktivovn edit_boxu "polomerne"
  (mode_tile "pocetne"      0)	;;; aktivovn edit_boxu "pocetne"
  (mode_tile "vzdalenostne" 0)	;;; aktivovn edit_boxu "vzdalenostne" 
  (mode_tile "pocvrcholune" 0)	;;; aktivovn edit_boxu "pocvrcholune"
  (mode_tile "polomerns"    0)	;;; aktivovn slideru "polomerns"
  (mode_tile "pocetns"      0)	;;; aktivovn slideru "pocetns" 
  (mode_tile "vzdalenostns" 0)	;;; aktivovn slideru "vzdalenostns" 
  (mode_tile "pocvrcholuns" 0)	;;; aktivovn slideru "pocvrcholuns"
  (mode_tile "nuhel_stred_but" 0)	;;; aktivovn tlatka "nuhel_stred_but" 
)

(defun so:vazba_prvku (val why editbox slider)
;;; funkce pro nastaven odpovdajcch prvk na stejn hodnoty
;;; pklad editbox1 a slider1 atd.
;;; val - nastavovan hodnota
;;; why - uruje jak akce uivatele vyvolala akci dialogovho   prvku
;;; editbox - jmno prvku typu editbox
;;; slider - jmno odpovdajcho prvku typu slider

  (if (or (= why 2) (= why 1))
;;; zjisten jak akce uivatele zpsobila akci dialogu
;;; 2 = opustn editboxu
;;; 1 = uivatel vybral prvek (pklad entrem)
    (progn
      (setq edit_hodnota (atof val))
;;; peveden etzce reprezentujcho nastavenou hodnotu   na slo
      (if (> edit_hodnota 100)
	(setq val "100")	;;; je-li slo mimo rozsah prvku, prove korekci
      )
      (if (< edit_hodnota 0)
	(setq val "0")		;;; je-li slo mimo rozsah prvku, prove korekci
      )
      (if (and (= editbox "pocvrcholune") (< edit_hodnota 3))
	(setq val "3")		;;; kontrola jestli nezadvme poet vrchol n-helnku <   3
      )
      (if (and (= editbox "polomerne") (< edit_hodnota 30))
	(setq val "30")	;;; kontrola jestli nezadvme polomr opsan krunice n-helnku   < 3
      )
      (set_tile editbox val)	;;; nastaven editboxu na sprvnou hodnotu
      (set_tile slider val)	;;; nastaven slideru na sprvnou hodnotu
      (setq gl_pam_hodnoty
	(subst
	  (cons editbox val)
	  (assoc editbox gl_pam_hodnoty)
	  gl_pam_hodnoty
	)
      )
      (setq gl_pam_hodnoty
	(subst
	  (cons slider val)
	  (assoc slider gl_pam_hodnoty)
	  gl_pam_hodnoty
	)
      )
    )
  )
)